use ifuicetest;

drop table if exists lds;
drop table if exists objecttype;
drop table if exists datasource;
drop table if exists mapping;
drop table if exists mappingtype;

drop table if exists object;
drop table if exists attribute;
drop table if exists attribute_temp;
drop table if exists attribute_fused;
drop table if exists mapresult;
drop table if exists mapresult_temp;
drop table if exists queryresult;
drop table if exists queryresult_temp;

drop table if exists var_object;
drop table if exists var_object_store;
drop table if exists var_mapresult;
drop table if exists var_mapresult_store;
drop table if exists var_aggregatedobject;
drop table if exists var_aggregatedobject_store;
drop table if exists var_aggregatedmappingresult;
drop table if exists var_aggregatedmappingresult_store;
drop table if exists var_string;
drop table if exists var_integer;
drop table if exists var_float;

drop table if exists op_object;
drop table if exists op_mapresult;
drop table if exists op_aggregatedobject;
drop table if exists op_aggregatedmappingresult;

drop table if exists op_query;
drop table if exists op_query1;
drop table if exists op_query2;

drop table if exists tree_tree;
drop table if exists tree_nodeaggregatedobject;
drop table if exists tree_nodeaggregatedobject_store;
drop table if exists tree_nodemappingtype;
drop table if exists tree_edge_aomt;
drop table if exists tree_edge_mtao;
 

# Host: localhost
# Database: mappingresults
# Table: 'attribute'
# 
CREATE TABLE `attribute` (
  `Attr_ID` int(11) NOT NULL auto_increment,
  `Attr_ObjectID_FK` int(11) NOT NULL default '0',
  `Attr_Name` varchar(1000) NOT NULL default '',
  `Attr_Value` varchar(1000) NOT NULL default '',
  PRIMARY KEY  (`Attr_ID`),
  KEY `index-objectid` (`Attr_ObjectID_FK`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'attribute_fused'
# 
CREATE TABLE `attribute_fused` (
  `attr_id` int(11) NOT NULL auto_increment,
  `attr_varid_fk` int(11) NOT NULL default '0',
  `attr_sameid_fk` int(11) NOT NULL default '0',
  `attr_name` varchar(1000) NOT NULL default '',
  `attr_value` varchar(1000) NOT NULL default '',
  PRIMARY KEY  (`attr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'attribute_temp'
# ENGINE=HEAP
CREATE TABLE `attribute_temp` (
  `Attr_ObjectID_FK` int(11) NOT NULL default '0',
  `Attr_Name` varchar(1000) NOT NULL default '',
  `Attr_Value` varchar(1000) NOT NULL default '',
  `Attr_Obj_ldsID_FK` int(11) NOT NULL default '0',
  `Attr_Obj_AttributeIDValue` varchar(990) default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'datasource'
# 
CREATE TABLE `datasource` (
  `ds_id` int(11) NOT NULL auto_increment,
  `ds_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`ds_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'lds'
# 
CREATE TABLE `lds` (
  `lds_id` int(11) NOT NULL auto_increment,
  `lds_attributename` varchar(100) NOT NULL default '',
  `lds_objecttypeid_fk` int(11) NOT NULL default '0',
  `lds_datasourceid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`lds_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'mapping'
# 
CREATE TABLE `mapping` (
  `map_id` int(11) NOT NULL auto_increment,
  `map_mappingtypeid_fk` int(11) NOT NULL default '0',
  `map_name` varchar(100) NOT NULL default '',
  `map_inputldsid_fk` int(11) NOT NULL default '0',
  `map_outputldsid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`map_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'mappingtype'
# 
CREATE TABLE `mappingtype` (
  `mt_id` int(11) NOT NULL auto_increment,
  `mt_inputobjecttypeid_fk` int(11) NOT NULL default '0',
  `mt_outputobjecttypeid_fk` int(11) NOT NULL default '0',
  `mt_issamemapping` tinyint(1) NOT NULL default '0',
  `mt_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`mt_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'mapresult'
# 
CREATE TABLE `mapresult` (
  `MR_ID` int(11) NOT NULL auto_increment,
  `MR_MappingID_FK` int(11) NOT NULL default '0',
  `MR_Confidence` float default '1',
  `MR_LeftObjectID_FK` int(11) NOT NULL default '0',
  `MR_RightObjectID_FK` int(11) default NULL,
  `mr_param` varchar(255) default NULL,
  PRIMARY KEY  (`MR_ID`),
  UNIQUE KEY `Unique` (`MR_MappingID_FK`,`MR_LeftObjectID_FK`,`MR_RightObjectID_FK`,`mr_param`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'mapresult_temp'
# 
CREATE TABLE `mapresult_temp` (
  `mr_id` int(11) NOT NULL auto_increment,
  `mr_mappingid_fk` varchar(100) default '',
  `mr_confidence` float default '1',
  `mr_rightldsid_fk` int(11) NOT NULL default '0',
  `mr_rightattributeidvalue` varchar(990) default '',
  `mr_leftldsid_fk` int(11) NOT NULL default '0',
  `mr_leftattributeIDValue` varchar(990) default NULL,
  `mr_param` varchar(255) default NULL,
  PRIMARY KEY  (`mr_id`)
) ENGINE=HEAP DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'object'
# 
CREATE TABLE `object` (
  `Obj_ID` int(11) NOT NULL auto_increment,
  `Obj_LDSID_FK` int(11) NOT NULL default '0',
  `Obj_SameObjectId_FK` int(11) default NULL,
  `Obj_AttributeIDValue` varchar(990) default '',
  PRIMARY KEY  (`Obj_ID`),
  UNIQUE KEY `unique-lds-attributeidvalue` (`Obj_LDSID_FK`,`Obj_AttributeIDValue`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'objecttype'
# 
CREATE TABLE `objecttype` (
  `ot_id` int(11) NOT NULL auto_increment,
  `ot_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`ot_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'op_aggregatedmappingresult'
# 
CREATE TABLE `op_aggregatedmappingresult` (
  `opamr_id` int(11) NOT NULL auto_increment,
  `opamr_inputobjectid_fk` int(11) NOT NULL default '0',
  `opamr_outputobjectid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`opamr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'op_aggregatedobject'
# 
CREATE TABLE `op_aggregatedobject` (
  `opao_id` int(11) NOT NULL auto_increment,
  `opao_objectid_fk` int(11) NOT NULL default '0',
  `opao_samegroup` int(11) NOT NULL default '0',
  `opao_ldsid_fk` int(11) NOT NULL default '0',
  `opao_flag` int(11) NOT NULL default '0',
  PRIMARY KEY  (`opao_id`),
  KEY `index` (`opao_samegroup`)
) ENGINE=HEAP DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'op_mapresult'
# 
CREATE TABLE `op_mapresult` (
  `opmr_id` int(11) NOT NULL auto_increment,
  `opmr_inputobjectid_fk` int(11) NOT NULL default '0',
  `opmr_inputsameid_fk` int(11) default '0',
  `opmr_inputldsid_fk` int(11) default '0',
  `opmr_inputconfidence` float NOT NULL default '0',
  `opmr_outputobjectid_fk` int(11) default '0',
  `opmr_outputsameid_fk` int(11) default '0',
  `opmr_outputldsid_fk` int(11) default '0',
  `opmr_outputconfidence` float default '0',
  `opmr_confidence` float default '1',
  `opmr_occurence` int(11) default '0',
  `opmr_mapresultid_fk` int(11) default '0',
  `opmr_jd00` float default '0',
  `opmr_jd01` float default '0',
  `opmr_jd10` float default '0',
  `opmr_jd11` float default '0',
  `opmr_flag` int(11) NOT NULL default '0',
  PRIMARY KEY  (`opmr_id`),
  KEY `ind_opmr_inputobjectid` (`opmr_inputobjectid_fk`),
  KEY `ind_opmr_outputobjectid` (`opmr_outputobjectid_fk`)
) ENGINE=HEAP DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'op_object'
# 
CREATE TABLE `op_object` (
  `opobj_id` int(11) NOT NULL auto_increment,
  `opobj_objectid_fk` int(11) NOT NULL default '0',
  `opobj_confidence` float default '0',
  `opobj_flag` int(11) NOT NULL default '0',
  PRIMARY KEY  (`opobj_id`)
) ENGINE=HEAP DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'op_query'
# 
CREATE TABLE `op_query` (
  `op_samegroup` int(11) default NULL,
  `DBLP_series` varchar(100) default NULL,
  `DBLP_title` varchar(100) default NULL,
  `DBLP_xml_key` varchar(100) default NULL,
  `DBLP_year` varchar(100) default NULL,
  KEY `index` (`op_samegroup`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'op_query1'
# 
CREATE TABLE `op_query1` (
  `op_samegroup` int(11) default NULL,
  `DBLP_key` varchar(100) default NULL,
  `DBLP_name` varchar(100) default NULL,
  `DBLP_NoOfChildren` varchar(100) default NULL,
  `DBLP_series` varchar(100) default NULL,
  `DBLP_type` varchar(100) default NULL,
  `DBLP_year` varchar(100) default NULL
) ENGINE=HEAP DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'op_query2'
# 
CREATE TABLE `op_query2` (
  `op_samegroup` int(11) default NULL,
  `DBLP_author` varchar(100) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'queryresult'
# 
CREATE TABLE `queryresult` (
  `QR_ID` int(11) NOT NULL auto_increment,
  `QR_MappingID_FK` int(11) NOT NULL default '0',
  `QR_Confidence` float default '0',
  `QR_Query` varchar(1000) NOT NULL default '',
  `QR_ObjectID_FK` int(11) NOT NULL default '0',
  PRIMARY KEY  (`QR_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'queryresult_temp'
# 
CREATE TABLE `queryresult_temp` (
  `QR_MappingID_FK` int(11) NOT NULL default '0',
  `QR_Confidence` float default '0',
  `QR_Query` varchar(1000) NOT NULL default '',
  `QR_RightLDSID_FK` int(11) NOT NULL default '0',
  `QR_RightAttributeIDValue` varchar(990) NOT NULL default ''
) ENGINE=HEAP DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'tree_edge_aomt'
# 
CREATE TABLE `tree_edge_aomt` (
  `edgeam_id` int(11) NOT NULL auto_increment,
  `edgeam_treeid_fk` int(11) NOT NULL default '0',
  `edgeam_nodeaoid_fk` int(11) NOT NULL default '0',
  `edgeam_nodemtid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`edgeam_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'tree_edge_mtao'
# 
CREATE TABLE `tree_edge_mtao` (
  `edgema_id` int(11) NOT NULL auto_increment,
  `edgema_treeid_fk` int(11) NOT NULL default '0',
  `edgema_nodemtid_fk` int(11) default '0',
  `edgema_nodeaoid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`edgema_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'tree_nodeaggregatedobject'
# 
CREATE TABLE `tree_nodeaggregatedobject` (
  `nao_id` int(11) NOT NULL auto_increment,
  `nao_treeid_fk` int(11) NOT NULL default '0',
  `nao_objecttypeid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`nao_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'tree_nodeaggregatedobject_store'
# 
CREATE TABLE `tree_nodeaggregatedobject_store` (
  `naostore_id` int(11) NOT NULL auto_increment,
  `naostore_treeid_fk` int(11) NOT NULL default '0',
  `naostore_nodeaoid_fk` int(11) NOT NULL default '0',
  `naostore_samegroup` int(11) NOT NULL default '0',
  `naostore_objectid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`naostore_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'tree_nodemappingtype'
# 
CREATE TABLE `tree_nodemappingtype` (
  `nmt_id` int(11) NOT NULL auto_increment,
  `nmt_treeid_fk` int(11) NOT NULL default '0',
  `nmt_mappingtypeid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`nmt_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'tree_tree'
# 
CREATE TABLE `tree_tree` (
  `tree_id` int(11) NOT NULL auto_increment,
  `tree_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`tree_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_aggregatedmappingresult'
# 
CREATE TABLE `var_aggregatedmappingresult` (
  `vamr_id` int(11) NOT NULL auto_increment,
  `vamr_name` varchar(100) NOT NULL default '',
  `vamr_inputobjects_varid_fk` int(11) NOT NULL default '0',
  `vamr_outputobjects_varid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`vamr_id`),
  UNIQUE KEY `Name` (`vamr_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_aggregatedmappingresult_store'
# 
CREATE TABLE `var_aggregatedmappingresult_store` (
  `vamrstore_id` int(11) NOT NULL auto_increment,
  `vamrstore_varid_fk` int(11) NOT NULL default '0',
  `vamrstore_confidence` float NOT NULL default '1',
  `vamrstore_occurence` int(11) NOT NULL default '1',
  `vamrstore_inputsamegroup` int(11) NOT NULL default '0',
  `vamrstore_outputsamegroup` int(11) NOT NULL default '0',
  PRIMARY KEY  (`vamrstore_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_aggregatedobject'
# 
CREATE TABLE `var_aggregatedobject` (
  `vao_id` int(11) NOT NULL auto_increment,
  `vao_objecttypeid_fk` int(11) NOT NULL default '0',
  `vao_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`vao_id`),
  UNIQUE KEY `Name` (`vao_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_aggregatedobject_store'
# 
CREATE TABLE `var_aggregatedobject_store` (
  `vaostore_id` int(11) NOT NULL auto_increment,
  `vaostore_varid_fk` int(11) NOT NULL default '0',
  `vaostore_objectid_fk` int(11) NOT NULL default '0',
  `vaostore_ldsid_fk` int(11) NOT NULL default '0',
  `vaostore_sort` int(11) default '0',
  `vaostore_samegroup` int(11) NOT NULL default '0',
  PRIMARY KEY  (`vaostore_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_float'
# 
CREATE TABLE `var_float` (
  `vfloat_id` int(11) NOT NULL auto_increment,
  `vfloat_name` varchar(100) NOT NULL default '',
  `vfloat_value` float NOT NULL default '0',
  PRIMARY KEY  (`vfloat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_integer'
# 
CREATE TABLE `var_integer` (
  `vint_id` int(11) NOT NULL auto_increment,
  `vint_name` varchar(100) NOT NULL default '',
  `vint_value` int(11) NOT NULL default '0',
  PRIMARY KEY  (`vint_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_mapresult'
# 
CREATE TABLE `var_mapresult` (
  `vmr_id` int(11) NOT NULL auto_increment,
  `vmr_inputldsid_fk` int(11) NOT NULL default '0',
  `vmr_outputldsid_fk` int(11) NOT NULL default '0',
  `vmr_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`vmr_id`),
  UNIQUE KEY `Name` (`vmr_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_mapresult_store'
# 
CREATE TABLE `var_mapresult_store` (
  `vmrstore_id` int(11) NOT NULL auto_increment,
  `vmrstore_varid_fk` int(11) NOT NULL default '0',
  `vmrstore_confidence` float default '1',
  `vmrstore_occurence` int(11) default '0',
  `vmrstore_inputobjectid_fk` int(11) NOT NULL default '0',
  `vmrstore_inputobject_confidence` float default '1',
  `vmrstore_outputobject_confidence` float default '1',
  `vmrstore_outputobjectid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`vmrstore_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_object'
# 
CREATE TABLE `var_object` (
  `vobj_id` int(11) NOT NULL auto_increment,
  `vobj_ldsid_fk` int(11) NOT NULL default '0',
  `vobj_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`vobj_id`),
  UNIQUE KEY `Name` (`vobj_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_object_store'
# 
CREATE TABLE `var_object_store` (
  `vobjstore_id` int(11) NOT NULL auto_increment,
  `vobjstore_varid_fk` int(11) NOT NULL default '0',
  `vobjstore_confidence` float default '0',
  `vobjstore_sort` int(11) NOT NULL default '0',
  `vobjstore_objectid_fk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`vobjstore_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

# Host: localhost
# Database: mappingresults
# Table: 'var_string'
# 
CREATE TABLE `var_string` (
  `vstr_id` int(11) NOT NULL auto_increment,
  `vstr_name` varchar(100) NOT NULL default '',
  `vstr_value` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`vstr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 


/*==============================================================*/
/* Database name:  REPOSITORY                                   */
/* DBMS name:      MySQL 3.23                                   */
/* Created on:     12.07.2005 18:39:34                          */
/*==============================================================*/

drop table if exists rep_expr_attr_rel;

drop table if exists rep_expression;

drop table if exists rep_correspondence;

drop table if exists rep_attribute;

drop table if exists rep_mapping;

drop table if exists rep_map_type;

drop table if exists rep_lds;

drop table if exists rep_pds;

drop table if exists rep_obj_type;

drop table if exists rep_map_path;

drop table if exists rep_smm_map_rel;

drop table if exists rep_smm;

/*==============================================================*/
/* Database name:  REPOSITORY                                   */
/* DBMS name:      MySQL 3.23                                   */
/* Created on:     12.07.2005 15:05:16                          */
/*==============================================================*/


/*==============================================================*/
/* Table: rep_obj_type                                          */
/*==============================================================*/
create table if not exists rep_obj_type
(
   obj_type_id                    int                            not null auto_increment,
   isa_obj_type_id                int,
   obj_type_name                  varchar(50)                    not null,
   primary key (obj_type_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_object_type                                   */
/*==============================================================*/
create index idx_rep_object_type on rep_obj_type
(
   obj_type_id,
   obj_type_name
);

/*==============================================================*/
/* Table: rep_pds                                               */
/*==============================================================*/
create table if not exists rep_pds
(
   pds_id                         int                            not null auto_increment,
   source_name                    varchar(50)                    not null,
   primary key (pds_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_pds                                           */
/*==============================================================*/
create index idx_rep_pds on rep_pds
(
   pds_id,
   source_name
);

/*==============================================================*/
/* Table: rep_lds                                               */
/*==============================================================*/
create table if not exists rep_lds
(
   lds_id                         int                            not null auto_increment,
   obj_type_id                    int                            not null,
   pds_id                         int                            not null,
   display                        varchar(100)                   default null,
   primary key (lds_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_lds                                           */
/*==============================================================*/
create index idx_rep_lds on rep_lds
(
   lds_id,
   obj_type_id,
   pds_id
);

/*==============================================================*/
/* Table: rep_map_type                                          */
/*==============================================================*/
create table if not exists rep_map_type
(
   map_type_id                    int                            not null auto_increment,
   input_obj_type_id              int                            not null,
   output_obj_type_id             int                            not null,
   map_type_name                  varchar(50)                    not null,
   is_same_map                    int                            not null default 0,
   primary key (map_type_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_map_type                                      */
/*==============================================================*/
create index idx_rep_map_type on rep_map_type
(
   map_type_id,
   input_obj_type_id,
   output_obj_type_id,
   map_type_name
); 

/*==============================================================*/
/* Table: rep_mapping                                           */
/*==============================================================*/
create table if not exists rep_mapping
(
   map_id                         int                            not null auto_increment,
   map_type_id                    int                            not null,
   input_lds_id                   int                            not null,
   output_lds_id                  int                            not null,
   is_only_id                     int                            not null default 0,
   is_id_output                   int                            not null default 0,
   map_name                       varchar(50)                    not null,
   map_class                      varchar(50)                    not null,
   exec_type                      varchar(50)                    not null,
   is_bulk_map                    int                            not null default 0,
   is_match_all                   int                            not null default 0,
   map_call                       varchar(5000)                  not null,
   safe_point_size                int                            not null default -1,
   primary key (map_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_mapping                                       */
/*==============================================================*/
create index idx_rep_mapping on rep_mapping
(
   map_id,
   map_type_id,
   input_lds_id,
   output_lds_id,
   map_name
);

/*==============================================================*/
/* Table: rep_attribute                                         */
/*==============================================================*/
create table if not exists rep_attribute
(
   attr_id                        int                            not null auto_increment,
   lds_id                         int                            not null,
   attr_name                      varchar(50)                    not null,
   is_key                         int                            not null default 0,
   is_mand                        int                            not null default 0,
   primary key (attr_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_attribute                                     */
/*==============================================================*/
create index idx_rep_attribute on rep_attribute
(
   attr_id,
   lds_id,
   attr_name
);

/*==============================================================*/
/* Table: rep_correspondence                                    */
/*==============================================================*/
create table if not exists rep_correspondence
(
   correspondence_id              int                            not null auto_increment,
   lds_1_id                       int                            not null,
   lds_2_id                       int                            not null,
   expr_1_id                      int,
   expr_2_id                      int,
   attr_1_id                      int,
   attr_2_id                      int,
   is_direct                      int                            default 0,
   is_equal                       int                            default 0,
   evidence                       float                          default 1,
   primary key (correspondence_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_correspondence                                */
/*==============================================================*/
create index idx_rep_correspondence on rep_correspondence
(
   correspondence_id,
   lds_1_id,
   lds_2_id
);

/*==============================================================*/
/* Table: rep_expression                                        */
/*==============================================================*/
create table if not exists rep_expression
(
   expr_id                      int                              not null auto_increment,
   expression                   varchar(100)                     not null,
   primary key (expr_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_expression                                    */
/*==============================================================*/
create index idx_rep_expression on rep_expression
(
   expr_id,
   expression
);

/*==============================================================*/
/* Table: rep_expr_attr_rel                                     */
/*==============================================================*/
create table if not exists rep_expr_attr_rel
(
   expr_id                      int                              not null,
   attr_id                      int                              not null,
   primary key (expr_id,attr_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_expr_attr_rel                                 */
/*==============================================================*/
create index idx_rep_expr_attr_rel on rep_expr_attr_rel
(
   expr_id,
   attr_id
);

/*==============================================================*/
/* Table: rep_map_path                                          */
/*==============================================================*/
create table if not exists rep_map_path
(
   map_path_id                    int                            not null,
   start_lds_id                   int                            not null,
   end_lds_id                     int                            not null,
   map_id                         int                            not null,
   is_same_path                   int                            not null,
   map_pos                        int                            not null,
   primary key (map_path_id, map_pos)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_mapping_path                                  */
/*==============================================================*/
create index idx_rep_mapping_path on rep_map_path
(
   start_lds_id,
   end_lds_id,
   map_id
);

/*==============================================================*/
/* Table: rep_smm                                               */
/*==============================================================*/
create table if not exists rep_smm
(
   smm_id                         int                            not null auto_increment,
   smm_name                       varchar(100)                   not null,
   is_loaded                      int                            not null default 0,
   primary key (smm_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_smm                                           */
/*==============================================================*/
create index idx_rep_smm on rep_smm
(
   smm_id,
   smm_name
);

/*==============================================================*/
/* Table: rep_smm_map_rel                                       */
/*==============================================================*/
create table if not exists rep_smm_map_rel
(
   smm_id                         int                            not null,
   map_id                         int                            not null,
   primary key (smm_id,map_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1; 

/*==============================================================*/
/* Index: idx_rep_smm_map_rel                                   */
/*==============================================================*/
create index idx_rep_smm_map_rel on rep_smm_map_rel
(
   smm_id,
   map_id
);