#!/usr/bin/perl
# 2005-01 david aumueller
# docs: http://perl.overmeer.net/mailbox/html/Mail::Message::Head/index.html

use strict;

#use MetaData; # see below

#use XML::RSS;
use Mail::Box;
use Mail::Box::Mbox;
use Mail::Internet;
#use Getopt::Std;
use Date::Manip;
#use vars qw($opt_h $opt_d);

#my $mbox = "testcase";
my $mbox = "dbworld";
my $sitelinkbase = "http://dbs.uni-leipzig.de/~david/2005/dbworld";
#my $channel = "DbWorld-X-Dates";
my $channel = "dbworldx";

my $messages = 0;

my $folder;
if ( -e $mbox) {
	$folder = Mail::Box::Mbox->new(folder=>$mbox, );
} else { 
	print "$mbox doesn't exist - $!\n";
	exit(1);
}


#@list = sort { $a <=> $b } $src_folder->messages;
my $emails = $folder->messages;
my @list = $folder->messages;

print "[$emails mails to process...]\n\n";

my $icalevents;
my %uniHash;
my %dbwHash;
my $counter;

foreach (@list) {
	my $msg = $folder->message( $messages );
	$messages++;
	print "\n[mail $messages/$emails] ";

	my $head = $msg->head();

	my $date  = $head->get('Date');
	my $from  = $head->get('From');
	# remove any stuff in parens like (CST) (date:manip parsedate doesnt like it)
	$date =~s/\(.*\)//;
	my $tstamp = &UnixDate($date, "%Y%m%d"."T"."%H%M%S");

	my Mail::Message::Field $subject = $head->get('subject');
	#my @rec = $head->get('received');
	#Mail::Message::Field @rec = $head->get('received');

	my $dbwMsgType	= $head->get('X-DBWorld-Message-Type');
	my $dbwName		= $head->get('X-DBWorld-Name');
	my $dbwStartDate= $head->get('X-DBWorld-Start-Date');
	my $dbwLocation	= $head->get('X-DBWorld-Location');
	my $dbwDeadline	= $head->get('X-DBWorld-Deadline');
	my $dbwCallFor	= $head->get('X-DBWorld-Call-For');
	my $dbwWebPage	= $head->get('X-DBWorld-Web-Page');

	my $metadata = MetaData->new();
	$metadata->set('tstamp', $tstamp);
	$metadata->set('subject', $subject);
	$metadata->set('from', $from);
	$metadata->set('msgType', $dbwMsgType);
	$metadata->set('name', $dbwName);
	$metadata->set('startDate', $dbwStartDate);
	$metadata->set('location', $dbwLocation);
	$metadata->set('deadline', $dbwDeadline);
	$metadata->set('callFor', $dbwCallFor);
	$metadata->set('webPage', $dbwWebPage);

	my %dbwMsgHash;
	%dbwMsgHash = { 
		msgType => $dbwMsgType,
		name    => $dbwName,
		startDate => $dbwStartDate,
		location => $dbwLocation,
		deadline => $dbwDeadline,
		callFor => $dbwCallFor,
		webPage => $dbwWebPage
	};


	my $dm = "_";
	my $uniquifier = $dbwName.$dm.$dbwMsgType.$dm.$dbwDeadline.$dm.$dbwStartDate;
#	$dbwHash{$tstamp} = \%dbwMsgHash; # zeiger auf hash
	my $hashPointer = \%dbwMsgHash;
	$dbwHash{$uniquifier} = $metadata;

}

my $xmlout = '<MAPRESULT inputdatasource="DbWorld" inputobjecttype="Conference" outputdatasource="DBLP" outputobjecttype="Conference" outputidattribute="dblpkey">';
   $xmlout.= "\n";
writeFile("ifuice_dbworld2dblp.map.xml", $xmlout);

   $xmlout = '<OBJECTINSTANCES objecttype="Conference" datasource="DbWorld" idAttribute="DbWorldTimestmap">';
   $xmlout.= "\n";
writeFile("ifuice_dbworld2dblp.obj.xml", $xmlout);

while ((my $key, my $value) = each %dbwHash) {
#	my $head = bless $value, "MetaData";
	my $head = $value;

	my $tstamp = $head->get('tstamp');
	my $subject = $head->get('subject');
	my $from = $head->get('from');
	my $dbwMsgType	= $head->get('msgType');
	my $dbwName		= $head->get('name');
	my $dbwStartDate= $head->get('startDate');
	my $dbwLocation	= $head->get('location');
	my $dbwDeadline	= $head->get('deadline');
	my $dbwCallFor	= $head->get('callFor');
	my $dbwWebPage	= $head->get('webPage');

	my $numericDeadline = &UnixDate($dbwDeadline, "%Y%m%d");
	my $confyear = &UnixDate($dbwStartDate, "%Y");
	my $confacronym = $dbwName;
	   $confacronym =~s/[0-9' :&-.]//g;
	   $confacronym = lc($confacronym);
	my $confdblpkey = "conf/$confacronym/$confyear";

	my $xmlout = "";
	   $xmlout.= "<MAP>";
	   $xmlout.= "<OBJECT datasource=\"DbWorld\">";
	   $xmlout.= "<IDVALUE>DbWorld$tstamp</IDVALUE>";
	   $xmlout.= "</OBJECT>";
	   $xmlout.= "<OBJECT datasource=\"DBLP\">";
	   $xmlout.= "<IDVALUE>$confdblpkey</IDVALUE>";
	   $xmlout.= "</OBJECT>";
	   $xmlout.= "</MAP>";
	   $xmlout.= "\n";

	appendFile("ifuice_dbworld2dblp.map.xml", $xmlout);
	
       $xmlout = "";
	   $xmlout.= "<OBJECT datasource=\"DbWorld\">";
	   $xmlout.= "<ATTRIBUTE><NAME>DbWorldTimestamp</NAME><VALUE>DbWorld$tstamp</VALUE></ATTRIBUTE>";
	   $xmlout.= "<ATTRIBUTE><NAME>MessageType</NAME><VALUE><![CDATA[$dbwMsgType]]></VALUE></ATTRIBUTE>";
   	   $xmlout.= "<ATTRIBUTE><NAME>ConfName</NAME><VALUE><![CDATA[$dbwName]]></VALUE></ATTRIBUTE>";
   	   $xmlout.= "<ATTRIBUTE><NAME>StartDate</NAME><VALUE><![CDATA[$dbwStartDate]]></VALUE></ATTRIBUTE>";
   	   $xmlout.= "<ATTRIBUTE><NAME>Location</NAME><VALUE><![CDATA[$dbwLocation]]></VALUE></ATTRIBUTE>";
   	   $xmlout.= "<ATTRIBUTE><NAME>Deadline</NAME><VALUE><![CDATA[$dbwDeadline]]></VALUE></ATTRIBUTE>";
   	   $xmlout.= "<ATTRIBUTE><NAME>CallFor</NAME><VALUE><![CDATA[$dbwCallFor]]></VALUE></ATTRIBUTE>";
   	   $xmlout.= "<ATTRIBUTE><NAME>Webpage</NAME><VALUE><![CDATA[$dbwWebPage]]></VALUE></ATTRIBUTE>";
	   $xmlout.= "</OBJECT>";
	   $xmlout.= "\n";

	appendFile("ifuice_dbworld2dblp.obj.xml", $xmlout);

}

$xmlout = "</MAPRESULT>\n";
appendFile("ifuice_dbworld2dblp.map.xml", $xmlout);

$xmlout = "</OBJECTINSTANCES>\n";
appendFile("ifuice_dbworld2dblp.obj.xml", $xmlout);


sub writeFile {
	my $filename = shift;
	my $data = shift;
	open(IC, ">$filename") || die "Datei nicht gefunden";
	print IC $data;
	close(IC);
}
sub appendFile {
	my $filename = shift;
	my $data = shift;
	open(IC, ">>$filename") || die "Datei nicht gefunden";
	print IC $data;
	close(IC);
}
#X-DBWorld-Message-Type: conference/announcement
#X-DBWorld-Name: MoMM2005
#X-DBWorld-Start-Date: 10-Sep-2005
#X-DBWorld-Location: Kuala Lumpur; Malaysia; Asia
#X-DBWorld-Deadline: 2-Apr-2005
#X-DBWorld-Call-For: papers, demos, exhibits, reports, Proposals
#X-DBWorld-Web-Page: http://www.iiwas.org/conferences/iiwas2005/




##################
package MetaData;

sub new {
 my $Objekt = shift;
 my $Referenz = {};
 bless($Referenz,$Objekt);
 return($Referenz);
}

sub set {
  my $Objekt = shift;
  my $Schluessel = shift;
  my $Wert = shift;
  $Objekt->{$Schluessel} = $Wert;
}

sub get {
  my $Objekt = shift;
  my $Schluessel = shift;
  return($Objekt->{$Schluessel})
}
1;
